import 'dart:math';

import 'package:circlegraph/bubble/bubblegraph.dart';
import 'package:circlegraph/circlegraph.dart';
import 'package:dashboard/data/cluster.dart';
import 'package:dashboard/data/community.dart';
import 'package:dashboard/graphing/trustcolorcalculator.dart';
import 'package:dashboard/loading.dart';
import 'package:dashboard/querying/clustergetter.dart';
import 'package:dashboard/querying/communitygetter.dart';
import 'package:dashboard/ui/graphs/community/community_graph_view_page.dart';
import 'package:dashboard/ui/graphs/community/list/cluster_list.dart';
import 'package:dashboard/ui/theme/color_holder.dart';
import 'package:dashboard/ui/util/logged_in_appbar.dart';
import 'package:flutter/material.dart';
import 'package:enhanced_future_builder/enhanced_future_builder.dart';

class ClusterGraph extends StatefulWidget {
  final List<Cluster> clusters;
  ClusterGraph(this.clusters);

  _ClusterGraphState createState() => _ClusterGraphState(this.clusters);
}

class _ClusterGraphState extends State<ClusterGraph> {
  final List<Cluster> clusters;
  int postNodeCount = 10; // Nr of postNodes displayed
  _ClusterGraphState(this.clusters);

  Widget build(BuildContext context) {
    return SingleChildScrollView(
      scrollDirection: Axis.vertical,
      child: BubbleGraph(
        clusters
            .map(
              (Cluster cluster) => CircleGraph(
                root: TreeNodeData(
                  onNodeClick: (node, data) => Navigator.push(
                    context,
                    MaterialPageRoute(
                      builder: (context) => ClusterList(data, 0),
                    ),
                  ),
                  data: cluster,
                  backgroundColor: ColorHolder.color1,
                  child: Container(
                    constraints: BoxConstraints.expand(),
                    child: Stack(
                      children: [
                        Align(
                          alignment: Alignment.center,
                          child: Padding(
                            padding: const EdgeInsets.only(top: 32.0),
                            child: Row(
                              mainAxisSize: MainAxisSize.min,
                              children: [
                                Icon(
                                  Icons.group_work,
                                  color: ColorHolder.color2,
                                ),
                                Text(
                                  "${cluster.getDisplayLabel()}",
                                  style: TextStyle(
                                    color: ColorHolder.color2,
                                  ),
                                ),
                              ],
                            ),
                          ),
                        ),
                      ],
                    ),
                  ),
                  height: 160,
                  width: 160,
                ),
                circlify: true,
                backgroundColor: ColorHolder.color1,
              ),
            )
            .toList(),
      ),
    );

    // return SingleChildScrollView(
    //   child: Wrap(
    //     children: [
    //       for (Community community in communities)
    //         getCommunityNodeWidget(community)
    //     ],
    //   ),
    // );
  }
}
